#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"
//#define F_CPU 16000000UL
void out_c(uint8_t pin, uint8_t val)
{
    DDRC |= 1<<pin;
    if (val)
        PORTC |= 1<<pin;
    else
        PORTC &= ~(1<<pin);
}
usbMsgLen_t usbFunctionSetup(uchar data[8])
{
    usbRequest_t *rq = (void *)data;
    if (rq->bRequest == 0)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
        PORTC = rq->wValue.bytes[0];
	PORTB = 0b00011111;
	//PORTB = rq->wValue.bytes[1];
        return 0;
    }
    else if(rq->bRequest == 1)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
	PORTC = rq->wValue.bytes[0];
	PORTB = 0b00101111;
	return 1;
    }else if(rq->bRequest == 2)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
	PORTC = rq->wValue.bytes[0];
	PORTB = 0b00110111;
	return 1;
    }else if(rq->bRequest == 3)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
	PORTC = rq->wValue.bytes[0];
	PORTB = 0b00111011;
	return 1;
    }
    else if(rq->bRequest == 4)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
	PORTC = rq->wValue.bytes[0];
	PORTB = 0b00111101;
	return 1;
    }
    else if(rq->bRequest == 5)
    {
	DDRC = 0x3f;
	DDRC = 0x3f;
	PORTC = rq->wValue.bytes[0];
	PORTB = 0b00111110;
	return 1;
    }
    return 0;       	
}
int main()
{
	DDRC = 0b00111111;
	DDRB = 0b00111111;
	PORTC = 0x0f;
	PORTB = 0b00000000;
   	usbInit();
    	usbDeviceDisconnect();
    	_delay_ms(300);     /* fake USB disconnect for > 250 ms */
    	usbDeviceConnect();
    	sei();              /* enable interrupts */
	while (1)           /* main event loop */
    	{                
        	usbPoll();
 	}
 	return 0;
}

